window = require ("zoom-and-move-window")

function draw_lines (line)
	for i = 1, #line-2, 2 do
		love.graphics.line(line[i], line[i+1], line[i+2], line[i+3])
	end
end

function draw_curves (line)
	for i = 3, #line-2, 4 do
--		if i == 3 then
			love.graphics.line(love.math.newBezierCurve({line[i-2], line[i-1], line[i], line[i+1], line[i+2], line[i+3]}):render())
--		else
--			love.graphics.line(love.math.newBezierCurve({line[i-2], line[i-1], line[i], line[i+1], line[i+2], line[i+3]}):render())
--			love.graphics.line(love.math.newBezierCurve({line[i], line[i+1], 2*line[i]-line[i-2], 2*line[i+1]-line[i-1], line[i+2], line[i+3]}):render())
--		end
	end
end

function love.load()
	window:load()
	points = {}
end
 
-- Increase the size of the rectangle every frame.
function love.update(dt)
	window:update(dt)
end


 
function love.draw()
	window:draw()
	love.graphics.setColor(1,1,1)
	love.graphics.points(points)
	if #points > 2 then
--		love.graphics.line(points)
		draw_lines (points)
	end
	if #points > 4 then
		love.graphics.setColor(1,1,0)
--		love.graphics.line(love.math.newBezierCurve(points):render())
		
		if (#points+1)%2 then
			draw_curves (points)
		end
	end
end



 
function love.wheelmoved(x, y)
	window:wheelmoved(x, y)
end


function love.mousepressed(x, y, button, istouch)
	local tx, ty, zoom = window:mousepressed(x, y, button)
	
	x=(x-tx)/zoom
	y=(y-ty)/zoom
	
	if #points < 6 then
		if button == 1 then
			table.insert(points, x)
			table.insert(points, y)
		elseif button == 2 then
			table.remove(points, #points)
			table.remove(points, #points)
		end
	else
		if button == 1 then
			local a = {x=points[#points-3], y=points[#points-2]}
			local b = {x=points[#points-1], y=points[#points]}
			table.insert(points, 2*b.x-a.x)
			table.insert(points, 2*b.y-a.y)
			table.insert(points, x)
			table.insert(points, y)
		elseif button == 2 then
			table.remove(points, #points)
			table.remove(points, #points)
			table.remove(points, #points)
			table.remove(points, #points)
		end
	end
end

